<template lang="pug">
    .container(v-if="isRoot")
        ReplyForm(v-if="isLoggedIn" :show-cancel="false" :parent_author="comment.author" :parent_permlink="comment.permlink" @success="addReply")
        p(v-else)
            a(href="/login") Login with Hivesigner
            | &nbsp;to be able to comment this article
        transition(name="fade")
            .comments-section
                comments-tree(v-for="child in children" :comment="child")
    .tree-view(v-else)
        img.comment-avatar(:src="`//images.hive.blog/u/${comment.author}/avatar`")
        .comment-content
            h6.comment-header
                span @{{ comment.author }},
                span(:title='createdLocalTime | moment("DD MMMM YYYY, h:mm:ss")' aria-hidden="true")
                = " " + "{{ createdLocalTime | moment('from') }}"
            EditForm(v-if="isEditActive" :comment="comment" @cancel="closeEditForm()" @success="updateComment")
            div(v-else)
                span(v-if="hasLowRating && isHidden" @click="showHidden") Comment hidden due to low rating. Click to show
                span(v-else v-html="comment.rendered")
            small.text-muted
                ul
                    li.next-item
                        v-popover(:disabled="!isLoggedIn" )
                            span.comment-reply-link(:class="{ voted: isVotedByUser }" :title="isVotedByUser ? 'Voted' : 'Vote!'" aria-hidden="true").oi.oi-thumb-up
                            span {{ this.votes.length }}
                            VotingSlider(slot="popover" :author="comment.author" :permlink="comment.permlink" @success="getAllProps()")
                    li.next-item
                        span(class="oi" :class="{ 'no-payout': noPayout }") ${{ value.toFixed(2) }}
                    li.next-item
                        span.comment-reply-link(@click="openReplyForm()") Reply
                    li(v-if="comment.author == username").next-item
                        span.comment-reply-link(@click="openEditForm()") Edit
                    span(v-if="comment.children")
                        li.next-item(v-if="expanded" @click="() => {this.expanded = false}")
                            span(class="oi oi-caret-top" aria-hidden="true" ).comment-reply-link
                        li.next-item(v-else @click="() => {this.expanded = true}")
                            span(class="oi oi-caret-bottom" aria-hidden="true" ).comment-reply-link
            ReplyForm(
                v-if="isReplyFormOpened"
                :parent_author="comment.author"
                :parent_permlink="comment.permlink"
                @cancel="closeReplyForm()"
                @success="addReply($event, comment)")
        transition(name="fade")
            .children(v-if="expanded")
                comments-tree(v-for="child in children" :comment="child")
</template>

<script lang="ts">
    import Vue from 'vue';
    import Vuex from 'vuex';

    import ReplyForm from './ReplyForm.vue';
    import EditForm from './EditForm.vue';
    import VotingSlider from './VotingSlider.vue';
    import CommentsService from "../../services/CommentsService";
    import VotingService from "../../services/VotingService";
    import moment = require("moment");

    export default Vue.extend({
        name: "comments-tree",
        components: {
            ReplyForm,
            EditForm,
            VotingSlider
        },
        props: {
            comment: {
                type: Object,
                required: true
            },
            isRoot: {
                type: Boolean,
                required: true,
                default: false
            }
        },

        data() {
            return {
                children: [],
                votes: [],
                value: 0,
                expanded: true,
                isReplyFormOpened: false,
                isEditActive: false,
                isHidden: false
            }
        },

        methods: {
            openReplyForm() {
                if(this.isLoggedIn) {
                    this.isReplyFormOpened = true;
                }
            },
            closeReplyForm() {
                this.isReplyFormOpened = false;
            },
            openEditForm() {
                this.isEditActive = true;
            },
            closeEditForm() {
                this.isEditActive = false;
            },
            showHidden() {
                this.isHidden = false;
            },
            addReply(reply: any, comment: any) {
                console.log(reply, comment);
                this.children.push({
                    parent_permlink: comment.permlink,
                    parent_author: comment.author,
                    permlink: reply.permlink,
                    author: reply.author,
                    title: reply.title,
                    body: reply.body,
                    rendered: reply.rendered,
                    created: moment.utc().format(),
                    net_votes: 0,
                    pending_payout_value: '0.000 SBD',
                    total_payout_value: '0.000 SBD'

                })
                this.closeReplyForm();
            },
            updateComment(rendered: string) {
                this.isEditActive = false;
                this.comment.rendered = rendered;
            },
            getVoters() {
                CommentsService.getVotes(this.$props.comment.author, this.$props.comment.permlink)
                    .then((votes: any) => {
                        this.votes = votes;
                    }).catch((error: Error) => {
                    console.error(error);
                })
            },
            getValue() {
                VotingService.getValue(this.$props.comment.author, this.$props.comment.permlink)
                    .then( (value: number) => {
                        this.value = value;
                    })
            },
            getAllProps() {
                this.getVoters();
                this.getValue();
            }

        },

        computed: {
            createdLocalTime() {
                return moment.utc(this.comment.created).local()
            },
            username() {
                return this.$store.state.sso.username;
            },
            isLoggedIn() {
                return !!this.username;
            },
            next() {
                return {
                    permlink: this.comment.permlink,
                    author: this.comment.author
                }
            },
            label() {
                return this.comment.permlink + this.comment.author;
            },
            noPayout() {
                return this.comment.max_accepted_payout === '0.000 SBD';
            },
            hasLowRating() {
                return this.comment.net_rshares < 0;
            },
            isVotedByUser() {
                if (!this.username) {
                    return false;
                } else {
                    const voted = this.votes.reduce((voted: boolean, vote: any) => voted || vote.voter === this.username, false);
                    return voted;
                }
            }
        },

        mounted(): void {
            console.log('mounted', this.comment);

            if (this.hasLowRating) {
                this.isHidden = true;
            }

            this.getAllProps();

            if (this.$props.comment.author && this.$props.comment.permlink && this.$props.comment.children) {
                CommentsService.getComments(this.$props.comment.author, this.$props.comment.permlink)
                    .then((response: any) => {
                        console.log('got replies', response.data);
                        this.children = response.data
                    })
            }

        },
    })

</script>
